// BigDCT.java

class BigDCT {

TheFrame parent;

int[][] origAmatrix = new int[8][8];
int[][] origRmatrix = new int[8][8];
int[][] origGmatrix = new int[8][8];
int[][] origBmatrix = new int[8][8];

double[][] origYmatrix = new double[8][8];
double[][] origUmatrix = new double[8][8];
double[][] origVmatrix = new double[8][8];

double[][] tmpY = new double[8][8];
double[][] tmpU = new double[8][8];
double[][] tmpV = new double[8][8];


int imgw = 120; // image width
int imgh = 120; // image heigth

BigDCT(TheFrame parent)
{
	this.parent = parent;
	
}

public void start() {	
	
	for (int y = 0; y < imgw; y += 8)
    for (int x = 0; x < imgh; x += 8 ) {    	
    	
    	// grabben und in orig*matrix felder schreiben
    	parent.ii.grab8x8BlockForBigDCT( x,y );
    	origAmatrix = parent.ii.getCompleteAValues();	
		origRmatrix = parent.ii.getCompleteRValues();
		origGmatrix = parent.ii.getCompleteGValues();
		origBmatrix = parent.ii.getCompleteBValues();
		
		// convert RGB values to YUV values
		origYmatrix = parent.converter.RGB2Yuv_Y(origRmatrix,origGmatrix,origBmatrix);
		origUmatrix = parent.converter.RGB2Yuv_U(origRmatrix,origGmatrix,origBmatrix);
		origVmatrix = parent.converter.RGB2Yuv_V(origRmatrix,origGmatrix,origBmatrix);		
				
		// DCT				
		origYmatrix = parent.fdct.forwardDCT( origYmatrix );
		origUmatrix = parent.fdct.forwardDCT( origUmatrix );
		origVmatrix = parent.fdct.forwardDCT( origVmatrix );
				
		origYmatrix = parent.quantizer.quantY( origYmatrix );
		origUmatrix = parent.quantizer.quantUV( origUmatrix );
		origVmatrix = parent.quantizer.quantUV( origVmatrix );
						
		// IDCT
		origYmatrix = parent.idct.inverseDCT( origYmatrix );
		origUmatrix = parent.idct.inverseDCT( origUmatrix );
		origVmatrix = parent.idct.inverseDCT( origVmatrix );
				
		// convert YUV values to RGB values
		origRmatrix = parent.converter.Yuv2RGB_R(origYmatrix,origUmatrix,origVmatrix);
		origGmatrix = parent.converter.Yuv2RGB_G(origYmatrix,origUmatrix,origVmatrix);
		origBmatrix = parent.converter.Yuv2RGB_B(origYmatrix,origUmatrix,origVmatrix);
					
		parent.oi.setAValues( origAmatrix );				
		parent.oi.setRValues( origRmatrix );		
		parent.oi.setGValues( origGmatrix );
		parent.oi.setBValues( origBmatrix );
		parent.oi.pushRGBValues( x, y );
        parent.oi.createPicture();
    			
	} // end of loop
		
} // end of start()
	
} // end of class SmallDCT
