//Fade.java

import java.awt.*;
import java.lang.*;
import java.net.*;
import java.applet.*;
import java.io.*;
import javax.swing.*;

class Thoughts {
	static int MAX = 10;
	String theThoughts[] = new String[MAX];
	URL theUrls[] = new URL[MAX];
	Font theFonts[] = new Font[MAX];
	int R, G, B;
	int dr, dg, db;
	int rinit, ginit, binit;
	int rfinal, gfinal, bfinal;
	Color bgColor;
	boolean maxxed = false;
	boolean darker = false;
	int curr, count;

	Thoughts() {
		R = G = B = 0;
		dr = dg = db = 1;
		rinit = ginit = binit = 0;
		rfinal = gfinal = bfinal = 255;
		bgColor = new Color(R,G,B);
		curr = -1;
		count = 0;
	}

	public void SetBackground(int i, int j, int k) {
		R = rinit = i;
		G = ginit = j;
		B = binit = k;
		bgColor = new Color(R,G,B);
	}

	public Color GetBackground() {
		return bgColor;
	}

	public void SetTextColor(int i, int j, int k)
	{	rfinal = i;
		gfinal = j;
		bfinal = k;
	}

	public void SetChangeFactor(int i) {
		
		if(rfinal > rinit) dr = i;
		else if(rfinal == rinit) dr = 0;
		else dr = -i;
		
		if(gfinal > ginit) dg = i;
		else if(gfinal == ginit) dg = 0;
		else dg = -i;
		
		if(bfinal > binit) db = i;
		else if(bfinal == binit) db = 0;
		else db = -i;
	}

	public void AddThought(String idea, String url, String fontname, int fontstyle, int fontsize) {
		if(curr < MAX)
		{	curr++;
			count++;
			theThoughts[curr] = idea;
			try{
				theUrls[curr] = new URL(url);
			}catch(MalformedURLException e) {}
			theFonts[curr] = new Font(fontname, fontstyle, fontsize);
		}
	}

	public void Reset() {
		curr = 0;
	}

	public void Next() {
		curr++;
		if(curr >= count) Reset();
	}

	public void DrawThoughts(final Fade that, final Graphics g) {
		
		SwingUtilities.invokeLater(new Runnable(){             		
             	public void run(){   
		FontMetrics fm = that.getFontMetrics(theFonts[curr]);
		Color temp = new Color(R,G,B);
		g.setColor(temp);
		g.setFont(theFonts[curr]);
		g.drawString(theThoughts[curr],
				(that.getSize().width - fm.stringWidth(theThoughts[curr]))/2,
				(that.getSize().height + fm.getAscent())/2);
		} // public void run...       			
       		});// SwingUtilities.invoke... 
	}

	public URL GetCurrentURL() {
		return theUrls[curr];
	}

	public int ChangeColors() {
		int pause = 1;

		if(!maxxed)
		{  // Adjust colors to fade in...
			R += dr;
			G += dg;
			B += db;
			if(!((dr > 0 && R < rfinal) || (dr < 0 && R > rfinal)))
				R = rfinal;
			if(!((dg > 0 && G < gfinal) || (dg < 0 && G > gfinal)))
				G = gfinal;
			if(!((db > 0 && B < bfinal) || (db < 0 && B > bfinal)))
				B = bfinal;
			if(R == rfinal && G == gfinal && B == bfinal)
			{	maxxed = true;
				pause = 10;
			}
		}
		else
		{  // Adjust colors to fade out...
			R -= dr;
			G -= dg;
			B -= db;
			if(!((dr > 0 && R > rinit) || (dr < 0 && R < rinit)))
				R = rinit;
			if(!((dg > 0 && G > ginit) || (dg < 0 && G < ginit)))
				G = ginit;
			if(!((db > 0 && B > binit) || (db < 0 && B < binit)))
				B = binit;
			if(R == rinit && G == ginit && B == binit)
			{	maxxed = false;
				pause = 10;
				Next();
			}
		}
		return pause;
	}

}

//------------------------------------

public class Fade extends JPanel implements Runnable {
	Thoughts thoughts = new Thoughts();
	Thread runner = null;

	public Fade() {
		// Set the background...
		String bgRGB = "ffffff"; //getParameter("bgcolor");
		thoughts.SetBackground( HexToInt(bgRGB.substring(0,2)),
					HexToInt(bgRGB.substring(2,4)),
					HexToInt(bgRGB.substring(4)));		
		setBackground(thoughts.GetBackground());

		// Set the text color...
		String txtRGB = "000000";//getParameter("txtcolor");
		thoughts.SetTextColor( HexToInt(txtRGB.substring(0,2)),
				       HexToInt(txtRGB.substring(2,4)),
				       HexToInt(txtRGB.substring(4)));		

		// Set the delta for the changing color...
		String changeFactor = "1";//getParameter("changefactor");
		thoughts.SetChangeFactor(1);
		//thoughts.SetChangeFactor(Integer.valueOf(changeFactor).intValue());

		// Obtaining the data for the thoughts...
		GetThoughts(this);

		thoughts.Reset();
		setSize(new Dimension(300,150));
		startme();
		System.out.println("Test1");
	}

	public void startme() {
		if(runner == null)
		{	runner = new Thread(this);
			runner.setPriority(runner.MIN_PRIORITY);
			runner.start();
		}
	}

	public void update(Graphics g) {		
			thoughts.DrawThoughts(this, g);		
	}

	/*
	public boolean mouseDown(java.awt.Event evt, int x, int y) {
		super.getAppletContext().showDocument(thoughts.GetCurrentURL());
		return true;
	}

	public boolean mouseEnter(java.awt.Event evt, int x, int y) {		
		showStatus("Please wait...");
		return true;
	}
	*/

	public void run() {
		int sleepfactor;

		while(runner != null)
		{  sleepfactor = thoughts.ChangeColors();
			repaint();
			try{runner.sleep(25*sleepfactor);}catch(InterruptedException e) {}
		}
	}

	public String getAppletInfo() {
		return "TextFader";
	}

	

	public void GetThoughts(Fade that){
		
		String fontName;
		String font;
		int fontSize, fontStyle;			
					
		fontName = "TimesRoman";
		fontSize = 12;
		fontStyle = Font.PLAIN;
		String theText = "Loading images..."; 
		String theUrl = "www.uni-mannheim.de";
		thoughts.AddThought(theText, theUrl, fontName, fontStyle, fontSize);
		
		theText = "...please wait !"; 
		thoughts.AddThought(theText, theUrl, fontName, fontStyle, fontSize);		
	}

	public int HexToInt(String value) {
		int answer = 0;

		if(value.substring(0,1).equalsIgnoreCase("a"))
			answer = 160;
		else if(value.substring(0,1).equalsIgnoreCase("b"))
			answer = 176;
		else if(value.substring(0,1).equalsIgnoreCase("c"))
			answer = 192;
		else if(value.substring(0,1).equalsIgnoreCase("d"))
			answer = 208;
		else if(value.substring(0,1).equalsIgnoreCase("e"))
			answer = 224;
		else if(value.substring(0,1).equalsIgnoreCase("f"))
			answer = 240;
		else
			answer = Integer.valueOf(value.substring(0,1)).intValue() * 16;

		if(value.substring(1).equalsIgnoreCase("a"))
			answer += 10;
		else if(value.substring(1).equalsIgnoreCase("b"))
			answer += 11;
		else if(value.substring(1).equalsIgnoreCase("c"))
			answer += 12;
		else if(value.substring(1).equalsIgnoreCase("d"))
			answer += 13;
		else if(value.substring(1).equalsIgnoreCase("e"))
			answer += 14;
		else if(value.substring(1).equalsIgnoreCase("f"))
			answer += 15;
		else
			answer += Integer.valueOf(value.substring(1)).intValue();

		return answer;
	}

}
