//class ImageLoader

import java.applet.*;
import java.awt.*;
import java.awt.Image;
import java.awt.MediaTracker;
import java.net.*;
import javax.swing.*;

class ImageLoader extends JPanel{

Image portrImage;
Image backgroundImage;
Image[] patternImages = new Image[5];

MediaTracker mt;

AppletContext ac;
URL codebase;

ImageLoader( URL codebase, AppletContext ac ) {
	
	this.codebase = codebase;
	this.ac = ac;
		
	mt = new MediaTracker( this );

	try {
		portrImage       = new ImageIcon(new URL(codebase, "images/ich_72dpi.gif")).getImage();	
		backgroundImage  = new ImageIcon(new URL(codebase, "images/backwood.jpg")).getImage();
		patternImages[0] = new ImageIcon(new URL(codebase, "images/kangoo.gif")).getImage();
		patternImages[1] = new ImageIcon(new URL(codebase, "images/darts.gif")).getImage();
		patternImages[2] = new ImageIcon(new URL(codebase, "images/apple.gif")).getImage();
		patternImages[3] = new ImageIcon(new URL(codebase, "images/ferrari.jpg")).getImage();
		patternImages[4] = new ImageIcon(new URL(codebase, "images/voyagercrew.gif")).getImage();
	} catch(MalformedURLException mURLe){System.out.println("Imageloader report: Error! Can't load images.");}	
	
	mt.addImage(portrImage,       0);
	mt.addImage(backgroundImage,  1);
	mt.addImage(patternImages[0], 2);
	mt.addImage(patternImages[1], 3);
	mt.addImage(patternImages[2], 4);
	mt.addImage(patternImages[3], 5);
	mt.addImage(patternImages[4], 6);
	
	
	ac.showStatus("Loading Image 1 of 7");
	try { mt.waitForID(0); } catch (InterruptedException ign) {}		
	ac.showStatus("Loading Image 2 of 7");
	try { mt.waitForID(1); } catch (InterruptedException ign) {}			
	ac.showStatus("Loading Image 3 of 7");		
	try { mt.waitForID(2); } catch (InterruptedException ign) {}		
	ac.showStatus("Loading Image 4 of 7");		
	try { mt.waitForID(3); } catch (InterruptedException ign) {}		
	ac.showStatus("Loading Image 5 of 7");
	try { mt.waitForID(4); } catch (InterruptedException ign) {}	
	ac.showStatus("Loading Image 6 of 7");		
	try { mt.waitForID(5); } catch (InterruptedException ign) {}		
	ac.showStatus("Loading Image 7 of 7");
	try { mt.waitForID(6); } catch (InterruptedException ign) {}		
	ac.showStatus("Image load process complete !");
	
} // constructor

} // end of class ImageLoader


// test
// try {Thread.sleep(2000); } catch (InterruptedException ie){}