// class InputImage.java

import javax.swing.*;
import java.awt.*;
import java.awt.image.*;
import java.awt.image.ImageProducer;
import java.awt.image.PixelGrabber;
import java.awt.image.ColorModel;
import java.awt.image.ImageObserver;
import java.awt.image.CropImageFilter;
import java.awt.image.FilteredImageSource;


class InputImage extends JPanel implements Runnable {

TheFrame parent;

Thread thread;

Image currentImage=null, magnify;
ImageProducer ip;
PixelGrabber pg;
ColorModel cm;
ImageObserver imo;
CropImageFilter cif;
String file;
int i, j, recx, recy, x, y,dx, dy, reccolor;
int[] grab;
int[][] amatrix;
int[][] rmatrix;
int[][] gmatrix;
int[][] bmatrix;
int[][] completeamatrix;
int[][] completermatrix;
int[][] completegmatrix;
int[][] completebmatrix;

boolean drawRecOnly = false;

InputImage(TheFrame parent) {
    
    this.parent = parent;   
          
    grab = new int[64];
    amatrix = new int[8][8];
    rmatrix = new int[8][8];
    bmatrix = new int[8][8];
    gmatrix = new int[8][8];
    completeamatrix = new int[8][8];
    completermatrix = new int[8][8];
    completebmatrix = new int[8][8];
    completegmatrix = new int[8][8];
    
    for (int i=0;i<8;i++)
    for (int j=0;j<8;j++) {
    	amatrix[i][j]=255;
	   	rmatrix[i][j]=255;
		bmatrix[i][j]=255;
		gmatrix[i][j]=255;}        
    
    reccolor = 255;
    recx = 64;
    recy = 64;
    x = 0 ;
    y = 0;
    dx = 120;
    dy = 120;   
    
    changeImage( 0 );   
    changeCursorPos( recx,recy );  
    
    thread = new Thread(this);
    thread.setPriority( 3 );
    thread.start();     
    
} // end of constructor


public void run() {
	
	boolean forward = false;

	while (true) {
		
		if (forward) { 
			reccolor += 1;
			if (reccolor >= 255) { forward = false; }
		} else {
			reccolor -= 1;
			if (reccolor <= 0) { forward = true; }
		} // else		
			
		if (reccolor % 150 == 0) { drawRecOnly = false; }
		repaint();	
		
		try {Thread.sleep(1);} catch (InterruptedException e) {}
	} // end while
} // end of run


public void paintComponent( Graphics g ){
	super.paintComponent(g);
	
	if (currentImage != null) { 		
		
		g.drawImage( currentImage, x, y, dx, dy, this );  
		g.setColor(new Color(reccolor,reccolor,reccolor));			
     	g.drawRect( recx, recy, 10, 10 );		
	}
} // end of paintComponent

public void changeCursorPos( int x, int y ){
    recx = x - 4; // 4 ist die halbe Breite/Höhe des Rechtecks
    recy = y - 4;
    grab8x8Block( x-3,y-2 );    
    repaint();    
  }


public void changeImage( int whichimage ) {
	
	int changeImage = 0;	
				
	if (whichimage == 0) {		
		currentImage = parent.imageloader.patternImages[0];
		changeImage = 1;				
	}

	if (whichimage == 1) {		
		currentImage = parent.imageloader.patternImages[1];
		changeImage = 1;		
	}

	if (whichimage == 2) {		
		currentImage = parent.imageloader.patternImages[2];
		changeImage = 1;			
	}

	if (whichimage == 3) {		
		currentImage = parent.imageloader.patternImages[3];
		changeImage = 1;		
	}
	
	if (whichimage == 4) {		
		currentImage = parent.imageloader.patternImages[4];
		changeImage = 1;		
	}	
	
	if (changeImage == 1) {
    	cif = new CropImageFilter( 0, 0, 120, 120 );
    	ip = currentImage.getSource();
    	ip = new FilteredImageSource( ip, cif );
    	currentImage = createImage( ip );
    }	
	
	drawRecOnly = false;	
	repaint();	
	grab8x8Block( recx,recy );	
} // end of changeImage


public void grab8x8Block( int x, int y ) {
	pg = new PixelGrabber( ip, x, y, 8, 8, grab, 0, 8 );
	try{
		pg.grabPixels();
	} catch  (InterruptedException  e)  { return; }
			
	for( i = 0; i < 8; i += 1 )
	for( j = 0; j < 8; j += 1 ) {
		amatrix[i][j] = (( grab[8*j+i] >> 24 ) & 0xff);
		rmatrix[i][j] = (( grab[8*j+i] >> 16 ) & 0xff);
		gmatrix[i][j] = (( grab[8*j+i] >> 8 ) & 0xff);
		bmatrix[i][j] = (( grab[8*j+i] ) & 0xff);		
	}
}

public void grab8x8BlockForBigDCT( int x, int y ){
    pg = new PixelGrabber( ip, x, y, 8, 8, grab, 0, 8 );
    try{
      pg.grabPixels();
    }
    catch  (InterruptedException  e)  { return; }
    
    for( i = 0; i < 8; i += 1 )
    for( j = 0; j < 8; j += 1 ) {
        completeamatrix[i][j] = (( grab[8*j+i] >> 24 ) & 0xff);
        completermatrix[i][j] = (( grab[8*j+i] >> 16 ) & 0xff);
        completegmatrix[i][j] = (( grab[8*j+i] >> 8 ) & 0xff);
        completebmatrix[i][j] = (( grab[8*j+i] ) & 0xff);
    }
}



/* ****** some return methods ****** */

final int[][] getRValues() {
	return rmatrix;
}
  
final int[][] getGValues() {
    return gmatrix;
}
  
final int[][] getBValues() {
    return bmatrix;
}

final int[][] getCompleteAValues() {
    return completeamatrix;
}

final int[][] getCompleteRValues() {
    return completermatrix;
}
  
final int[][] getCompleteGValues() {
    return completegmatrix;
}
  
final int[][] getCompleteBValues() {
    return completebmatrix;
}

}  // end of class InputImage













