// Menubar.java
import java.awt.*;
import java.awt.event.*;
import java.net.URL;
import javax.swing.*;

class Menubar extends JMenuBar implements ActionListener {	
	
JMenu programMenu = new JMenu("Program"),
      helpMenu = new JMenu("?");

JMenuItem menuitem;

TheFrame parent;
			
Menubar(TheFrame parent)
{	
	this.parent = parent;	
			
	menuitem = new JMenuItem("Quit");
	menuitem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Q, InputEvent.CTRL_MASK));
	menuitem.addActionListener(this);
		
	programMenu.add(menuitem);				
		
	menuitem = new JMenuItem("Help");
	menuitem.addActionListener(this);
	helpMenu.add(menuitem);

	menuitem = new JMenuItem("About");
	menuitem.addActionListener(this);
	helpMenu.add(menuitem);
	
	// the menubar itself
	add(programMenu);	
	add(helpMenu);
			
} // end of constructor 

	
// ************************************** Action Performed *********************************************	
	
public void actionPerformed(ActionEvent evt)
{			
	if (evt.getSource() instanceof JMenuItem)
	{		
		String arg = evt.getActionCommand();
			
		if (arg.equals("Quit"))
		{
			parent.dispose();
			//parent.appl.activ = false;			
			//System.exit(0);
		}
		
		if (arg.equals("Help")) 
		{			
			JDialog d = new Tutorial( parent );
			d.show();
		}
		
		if (arg.equals("About"))
		{	
			String message;
			//String file = "images/ich_72dpi.gif";
			//URL u = Menubar.class.getResource( file );
			//Icon messageIcon = new ImageIcon(parent.appl.getImage(u));
			Icon messageIcon = new ImageIcon(parent.imageloader.portrImage);
		
			message = "Visualizing the idea of JPEG compression:\n"+
				  "Discrete Cosine Transform & Quantiziation\n\n"+
				  "Author : Holger Wons\n"+
				  "Student of Computer Science and Business Administration\n"+				  
				  "\n\n\n\n\n"+
				  "(c) 2000 University of Mannheim\n "+
				  "Lehrstuhl für Praktische Informatik IV\n"+
				  "http://www.informatik.uni-mannheim.de/informatik/pi4\n"+
				  "http://www.uni-mannheim.de";
			
			JOptionPane.showMessageDialog
				(null,message,"About",JOptionPane.INFORMATION_MESSAGE,messageIcon); 				
		}
	}
	
	

} // end of public void actionPerformed...
		
} //end of class menubar extends JMenuBar
