// class OutputImage.java


//import java.*;
import javax.swing.*;

import java.awt.*;
import java.awt.image.*;
import java.awt.image.PixelGrabber;
import java.awt.image.ColorModel;
import java.awt.image.ImageObserver;
import java.awt.image.CropImageFilter;
import java.awt.image.FilteredImageSource;
import java.awt.image.ImageProducer;
import java.awt.image.MemoryImageSource;


class OutputImage extends JPanel {
	
  TheFrame parent;
  BorderLayout bl;
  Image outimage;
  ImageProducer ip;
  int i, j, x, y, dx, dy,imgw, imgh, imgl;
  int[] imgmatrix;
  int[][] amatrix;
  int[][] rmatrix;
  int[][] gmatrix;
  int[][] bmatrix;
  

OutputImage( TheFrame parent ) {
	
    this.parent = parent;
    
    imgw=120;
    imgh=120;    
    imgl = imgw * imgh;
    
    amatrix = new int[8][8];
    rmatrix = new int[8][8];
    bmatrix = new int[8][8];
    gmatrix = new int[8][8];
    
    for ( i = 0; i < 8; i++ )
    for ( j = 0; j < 8; j++ ) {
		amatrix[i][j] = 255;
		rmatrix[i][j] = 255;
		bmatrix[i][j] = 255;
		gmatrix[i][j] = 255;      
    }
    
    imgmatrix = new int[imgl];
    
    for ( i = 0; i < imgl; i++ )
    	imgmatrix[i] = (255<<24) | (255<<16) | (255<<8) | (255);
    
    this.setLayout( bl = new BorderLayout() );
    
    createPicture();
    
} // end of constructor


public void paintComponent( Graphics g ){
    g.drawImage( outimage, x, y, dx, dy, this );
}



public void createPicture() {
	
    ip = new MemoryImageSource( imgw, imgh, imgmatrix, 0, imgw );
    outimage = createImage( ip );
    
    x = 0;
    y = 0;    
    dx = 120;
    dy = 120;    
    
    repaint();    
}


public void pushRGBValues( int x, int y ) {
  	
    int pixel;
    for ( j = 0; j < 8; j++ )
    for ( i = 0; i < 8; i++ ) {
		pixel = 0;
		pixel = pixel | ( amatrix[i][j] << 24 );
		pixel = pixel | ( rmatrix[i][j] << 16 );
		pixel = pixel | ( gmatrix[i][j] << 8 );
		pixel = pixel | ( bmatrix[i][j] );
		imgmatrix[imgw*(y+j)+x+i] = pixel;      
    } // end of loop
} // end of push...



final void setAValues( int[][] matrix ) {
    amatrix = matrix;
}

final void setRValues( int[][] matrix ) {
	for ( j = 0; j < 8; j++ )
    for ( i = 0; i < 8; i++ ) {
    	if (matrix[i][j] < 0) { rmatrix[i][j] = 0; }
    	else if (matrix[i][j] > 255) { rmatrix[i][j] = 255; }
    	     else rmatrix[i][j] = matrix[i][j];
    }
}

final void setGValues( int[][] matrix ) {
	for ( j = 0; j < 8; j++ )
    for ( i = 0; i < 8; i++ ) {
    	if (matrix[i][j] < 0) { gmatrix[i][j] = 0; }
    	else if (matrix[i][j] > 255) { gmatrix[i][j] = 255; }
    	     else gmatrix[i][j] = matrix[i][j];
    }
}

final void setBValues( int[][] matrix ) {
	for ( j = 0; j < 8; j++ )
    for ( i = 0; i < 8; i++ ) {
    	if (matrix[i][j] < 0) { bmatrix[i][j] = 0; }
    	else if (matrix[i][j] > 255) { bmatrix[i][j] = 255; }
    	     else bmatrix[i][j] = matrix[i][j];
    }
}

} //end of class

