//class ShowBargraph

import java.awt.*;
import java.lang.Boolean;
import java.lang.Math;
import javax.swing.*;


public class ShowBargraph extends JPanel {
  double degrot;       // degree of rotation
  double scale_z;
  double scale_y;
  double scale_x;
  int x_offset;       // to move the output in the position you like
  int y_offset;
  int max_x;
  int max_y;
  int myzpos;       // z-position of the eye
  int myhight;      // the hight of my eye
  double x_factor;
  double y_factor;
  double z_factor;
  int[][] check_for_refresh;
  Color maincolor;
  int barsize;
  int matrix[][];
  
  public ShowBargraph() {
    //resize(100,200);
    setSize(new Dimension(100,100));
    Color cl = new Color( 100,100,100 );
    init (15,15,cl, 0.6, 0.4, 0.2);
  }
  

public void init(int max_x, int max_y, Color color, double sx, double sy, double sz) {
	
    int i;
    int j;
    degrot = (Math.PI*20)/180;
    maincolor = color;
    this.max_x = max_x;
    this.max_y = max_y;
    scale_y = sy; // 0.4
    scale_x = sx;  // 0.6
    scale_z = sz; // 0.2;
    x_factor =1.0;
    y_factor =1.0;
    z_factor = 1.0;
    x_offset = 27;//27
    y_offset = 60;//157
    barsize = 5;
    matrix = new int[8][8];
    check_for_refresh = new int[8][8];
    // initialize check_for_refresh
    for(i=0;i<=7;i++)
    for(j=0;j<=7;j++) {
		check_for_refresh[i][j] = -1;
    }    
}

public void repaintBars ( double[][] m ) {
	
	double[][] helpM = new double[8][8];
		
	for (int k = 0; k < 8; k++) helpM[k] = (double[])m[k].clone();
	
    for (int i=0;i<=7;i++)
    for (int j=0;j<=7;j++) { matrix[i][j] = (int) (Math.round(helpM[i][j]*1/2*z_factor)); }
    repaint();      
} 

public void drawGraph( Graphics g){
	int i;
	int j;   
	for (i=0;i<=7;i++)
	for (j=0;j<=7;j++) {   
		drawBar(g, (i*2*barsize)+barsize,(j*2*barsize)+barsize,Math.abs(matrix[i][j]));	}		
}

private void drawBar(Graphics g, int x, int y, int size){
    Color gray1 = new Color(120,120,120);
    Color gray2 = new Color(150,150,150);
    Color gray3 = new Color(60,60,60);
    g.setColor(maincolor);
    drawBarSide(g,x-barsize,y+barsize,0,x+barsize,y+barsize,size);
    g.setColor(maincolor.darker());   
    drawBarSide(g,x+barsize,y+barsize,0,x+barsize,y-barsize,size);
    g.setColor(maincolor.brighter());
    drawBarTop(g,x-barsize,y-barsize,x+barsize,y+barsize,size);    
}

private void drawBarSide(Graphics g, int x1,int y1,int z1,int x2,int y2,int z2) {
    int[] point_x = new int[5];
    int[] point_y = new int[5];
          
    convert(g,x1,y1,z1,point_x, point_y,0);
    convert(g,x1,y1,z2,point_x, point_y,1);
    convert(g,x2,y2,z2,point_x, point_y,2);
    convert(g,x2,y2,z1,point_x, point_y,3);
    g.fillPolygon(point_x,point_y,4);    
}


private void drawBarTop(Graphics g, int x1,int y1,int x2,int y2,int z1) {
    int[] point_x = new int[5];
    int[] point_y = new int[5];
    convert(g,x1,y1,z1,point_x, point_y,0);
    convert(g,x2,y1,z1,point_x, point_y,1);
    convert(g,x2,y2,z1,point_x, point_y,2);
    convert(g,x1,y2,z1,point_x, point_y,3);
    g.fillPolygon(point_x,point_y,4);    
}

public void convert(Graphics g, int x1, int y1, int z1, int ret_x[], int ret_y[],int index){
    int _x1;
    int _y1;
    double deg_1;
    double distance_1;   // distance of point 1 to (0,0)
    degrot = (Math.PI*20)/180;
    myhight= 100;//100
    myzpos= -50;
    distance_1 = Math.sqrt(Math.pow(x1,2) + Math.pow(y1,2));    
    deg_1 = Math.asin(y1/distance_1);
    deg_1 +=degrot;
    ret_x[index] =(int) (((Math.cos(deg_1)*distance_1))*x_factor)+x_offset;
    _y1=(int) (Math.sin(deg_1)*distance_1*scale_y);
    ret_y[index] = (int) ((_y1 - (int) ((z1)*scale_z))*y_factor)+y_offset;    
}

private boolean reallyPaint(){
    int i;
    int j;
    boolean check = false;
        
    for(i=0;i<=7;i++)
    for(j=0;j<=7;j++) {
		if (this.matrix[i][j] != this.check_for_refresh[i][j])
			check = true;      
    }
    
    if (check) {
      this.check_for_refresh = this.matrix;
      return(true);
    } else {
      return( false );
    }     
}


public void paintComponent(Graphics g) {
  	super.paintComponent(g);
  	/*  	
  	if ( reallyPaint() ) {  		
  		// Bei Darstellungsfehlern die beiden folgenden Zeilen wieder aktivieren		
    	//g.setColor ( getBackground());      
    	//g.fillRect(0,0,100,100);    	
    } 
    */    
    drawGraph(g);
}


} // end of class




