/******************************************************************************
 * Technical University of Darmstadt
 * Industrial Process and System Communication
 * Project: Discrete Fourier Transformation
 * Filename: ShowMatrix.java
 * Author: Markus Schumacher
 * Contents: Generates an 8x8 Extract of an Image using 8x8-Matrix
 * Last Changes: Christian Herzog
 *****************************************************************************/

import java.awt.*;
import javax.swing.*;


/*
import java.awt.Panel;
import java.awt.Graphics;
import java.awt.BorderLayout;
import java.awt.Color;
*/

/******************************************************************************
* Class: ShowBargraph
* Description:  calculates and shows the 8x8 matrices
******************************************************************************/
public class ShowMatrix extends JPanel {

BorderLayout bl;
int[][] rpixel, gpixel, bpixel;
int rval, gval, bval, i, j, size;


public ShowMatrix(){
    rpixel = new int[8][8];
    gpixel = new int[8][8];
    bpixel = new int[8][8];
    repaint();
}

public void paintComponent( Graphics g ) {
	
	super.paintComponent(g);
	
	size = (int)(getSize().getHeight() + getSize().getWidth())/14-2;
	
	for(int i = 0; i < 8; i++ )
	for(int j = 0; j < 8; j++ ) {
				
		rval = rpixel[i][j];
		gval = gpixel[i][j];
		bval = bpixel[i][j];
				
		if (rval > 255) { rval = 255;}
		if (gval > 255) { gval = 255;}
		if (bval > 255) { bval = 255;}
		
		if (rval < 0) { rval = 0;}
		if (gval < 0) { gval = 0;}
		if (bval < 0) { bval = 0;}
				
		g.setColor( new Color( rval, gval, bval ) );
		g.fillRect( i*size-1, j*size-1, size, size );
		g.setColor( Color.black );
		g.drawRect( i*size-1, j*size-1, size, size );
	}
}


public void repaintMatrix( int[][] rpix, int[][] gpix, int[][] bpix ){
    rpixel = rpix;
    gpixel = gpix;
    bpixel = bpix;
    repaint();
  }
}


