// SmallDCT.java

class SmallDCT {

TheFrame parent;

int [][] origRmatrix = new int[8][8];
int [][] origGmatrix = new int[8][8];
int [][] origBmatrix = new int[8][8];

double [][] origYmatrix = new double[8][8];
double [][] origUmatrix = new double[8][8];
double [][] origVmatrix = new double[8][8];


SmallDCT(TheFrame parent)
{
	this.parent = parent;
	
}

public void start() {	
	
	origRmatrix = parent.ii.getRValues();
	origGmatrix = parent.ii.getGValues();
	origBmatrix = parent.ii.getBValues();
	
	// convert RGB values to YUV values
	origYmatrix = parent.converter.RGB2Yuv_Y(origRmatrix,origGmatrix,origBmatrix);
	origUmatrix = parent.converter.RGB2Yuv_U(origRmatrix,origGmatrix,origBmatrix);
	origVmatrix = parent.converter.RGB2Yuv_V(origRmatrix,origGmatrix,origBmatrix);	
	
	// linke matrix anzeigen
	parent.gui.iim.repaintMatrix( origRmatrix,origGmatrix,origBmatrix );		
			
	// DCT
	origYmatrix = parent.fdct.forwardDCT( origYmatrix );
	origUmatrix = parent.fdct.forwardDCT( origUmatrix );
	origVmatrix = parent.fdct.forwardDCT( origVmatrix );
			
	// linke Balken zeichnen	
	parent.gui.dsbg.repaintBars( origYmatrix );	
		
	origYmatrix = parent.quantizer.quantY ( origYmatrix );	
	origUmatrix = parent.quantizer.quantUV( origUmatrix );	
	origVmatrix = parent.quantizer.quantUV( origVmatrix );
	
	// rechte Balken zeichnen	
	parent.gui.qsbg.repaintBars( origYmatrix );
	
	//parent.matrixPrint(origYmatrix);
			
	// IDCT
	origYmatrix = parent.idct.inverseDCT( origYmatrix );
	origUmatrix = parent.idct.inverseDCT( origUmatrix );
	origVmatrix = parent.idct.inverseDCT( origVmatrix );
			
	// convert YUV values to RGB values
	origRmatrix = parent.converter.Yuv2RGB_R(origYmatrix,origUmatrix,origVmatrix);
	origGmatrix = parent.converter.Yuv2RGB_G(origYmatrix,origUmatrix,origVmatrix);
	origBmatrix = parent.converter.Yuv2RGB_B(origYmatrix,origUmatrix,origVmatrix);
	
	//rechte Matrix anzeigen		
	parent.gui.oim.repaintMatrix( origRmatrix,origGmatrix,origBmatrix );		
}
	
} // end of class SmallDCT
