// TheEventHandler

import java.awt.*;
import java.awt.event.*;
import java.awt.Color.*;
import javax.swing.*;

class TheEventHandler implements ActionListener, AdjustmentListener, FocusListener, MouseListener
{
	
TheFrame parent;

int old = -1;
int oldval = 1;


TheEventHandler(TheFrame parent)
{
	this.parent = parent;
	
} // end of constructor


// ************************************** Action Performed *********************************************	
	
public void actionPerformed(ActionEvent evt) {	
	
//******************************** COMBOBOXES ****************************
if (evt.getSource() instanceof JComboBox) {			

	int i;
	
	if (evt.getSource() == parent.gui.CBimageChoser) {
	
		JComboBox source = (JComboBox)evt.getSource();
		i = (int)source.getSelectedIndex();
		if (i != old) {				
			parent.ii.changeImage( i );
			parent.sdct.start();
			parent.bdct.start();
			old = i;
		}
	}	
} // end ComboBox Handler
	
	
//******************************** TEXTFIELDS ****************************
if (evt.getSource() instanceof JTextField) {
	
String tmpstr = "";
int tmpint = 0;
int newval = 1;
	
	if (evt.getSource() == parent.gui.TFquantManuel) {
		
		tmpstr = parent.gui.TFquantManuel.getText().trim();
		try {
			tmpint = Integer.parseInt(tmpstr);			
			if (tmpint < 1) tmpint = 1;
			if (tmpint > 2048) tmpint = 2048;			
		} catch (Exception e) { tmpint = oldval;}		
		newval = tmpint;
			
		// scrollbar und textfeld auf newval setzen		
		parent.gui.TFquantManuel.setText( String.valueOf(newval) );
		parent.gui.SBquantSlider.setValue( newval );		
		oldval = tmpint;		
	}	
} // end of jtextfield handler
		
		
//******************************** BUTTONS ****************************		
if (evt.getSource() instanceof JButton) {
	
	if (evt.getSource() == parent.gui.BshowQTable) {
		
		JDialog d = new QuantizeDialog(parent,parent.quantizer.qTableLumi,parent.quantizer.qTableChro);
		d.show();		
	}
}

//******************************** RADIO BUTTONS ****************************		
if (evt.getSource() instanceof JRadioButton) {
	
	if ((JRadioButton)evt.getSource() == parent.gui.RBactivateScroller) {	
		parent.gui.SBquantSlider.setEnabled(true);
		parent.gui.TFquantManuel.setEnabled(true);		
		parent.quantizer.setNewQuantizeTable( parent.gui.SBquantSlider.getValue() );
		parent.sdct.start();
		parent.bdct.start();
	}
	
	if ((JRadioButton)evt.getSource() == parent.gui.RBactivateTable) {
		parent.gui.SBquantSlider.setEnabled(false);
		parent.gui.TFquantManuel.setEnabled(false);	
		parent.quantizer.setNewQuantizeTable( 0 );
		parent.sdct.start();
		parent.bdct.start();
	}	
}

		
//******************************** MENU OBJECTS ****************************		
if (evt.getSource() instanceof JMenuItem) {	
	
}	
	
} // end of public void ActionPerformed(Action evt)


// ************************************** Adjustment Value Changed *****************************************

public void adjustmentValueChanged(AdjustmentEvent evt)
{	
	String tmps = "";	
		
	if ((JScrollBar)evt.getSource() == parent.gui.SBquantSlider) {
		JScrollBar source = (JScrollBar)evt.getSource();
		if ( source.getValueIsAdjusting() ) {
			tmps = String.valueOf(source.getValue());
			parent.gui.TFquantManuel.setText(tmps);
		} else {
			tmps = String.valueOf(source.getValue());
			parent.gui.TFquantManuel.setText(tmps);
			parent.quantizer.setNewQuantizeTable(source.getValue());
			parent.sdct.start();
			parent.bdct.start();
		}
	}
				
} // end of public void adjustment value changed(...
	
// ************************************** FocusEvent occured *****************************************	
public void focusLost(FocusEvent evt)
{	
		
} // end of public void focusLost(FocusEvent evt)
	
	
public void focusGained(FocusEvent evt)
{ 	
			
}// end of public void focusGained(FocusEvent evt)


// ************************************** MouseEvent occured *****************************************	

public void mouseClicked(MouseEvent evt) { 	
	
	int x = evt.getX();
	int y = evt.getY();
	int px = (int)parent.ii.getSize().getWidth();
	int py = (int)parent.ii.getSize().getHeight();
	
	if (x <= 4) {x = 4;};
	if (x >= px-7) {x = px-7;};
	if (y <= 4) {y = 4;};
	if (y >= py-7) {y = py-7;};
	
	parent.ii.changeCursorPos( x,y );	
	parent.sdct.start();
}

public void mousePressed(MouseEvent evt) { 	
			
}

public void mouseReleased(MouseEvent evt) { 	
			
}

public void mouseEntered(MouseEvent evt) { 	
			
}

public void mouseExited(MouseEvent evt) { 	
			
}


} // end of class