// TheGUI.java

import java.awt.*;
import java.awt.event.*;
import java.awt.Color.*;
import java.awt.Image;
import java.net.URL;
import javax.swing.*;
import javax.swing.border.*;

class TheGUI { 	
	
int maxQ = 2048;
	
TheFrame parent;
TheEventHandler eventhandler;

Image backgroundImage, prevButtonImage, nextButtonImage;
JPanel mainPanel;
GridBagLayout gbl = new GridBagLayout();
GridBagConstraints gbc = new GridBagConstraints();

JButton BshowQTable = new JButton("Show quantize table");

JComboBox CBimageChoser = new JComboBox();

JScrollBar SBquantSlider = new JScrollBar(Adjustable.HORIZONTAL, 1, 1, 1, maxQ+1 );

JRadioButton RBactivateScroller, RBactivateTable;
ButtonGroup quantChoser = new ButtonGroup();

JLabel LtableText = new JLabel("Use JPEG Standard table");
JLabel LscrollerText = new JLabel("Divide by custom integer [1.."+maxQ+"]");

JTextField TFquantManuel = new JTextField("1",3);

InputImage inputImagePanel;
OutputImage outputImagePanel;

ShowMatrix iim;
ShowMatrix oim;
ShowBargraph dsbg;
ShowBargraph qsbg;
	
TheGUI(TheFrame parent)
{	
	this.parent = parent;	
	parent.setJMenuBar(new Menubar(parent));
		
	mainPanel = new backpanel(parent.imageloader.backgroundImage);		
	mainPanel.setLayout(gbl);
	
	inputImagePanel = parent.ii;
	outputImagePanel = parent.oi;
	
	iim = new ShowMatrix();
	oim = new ShowMatrix();
	
	dsbg = new ShowBargraph();
	qsbg = new ShowBargraph();
		
	CBimageChoser.setEditable(false);	
	CBimageChoser.addItem("Kangoo");	
	CBimageChoser.addItem("Darts");
	CBimageChoser.addItem("Apple");
	CBimageChoser.addItem("Ferrari");	
	CBimageChoser.addItem("Voyager Crew");	
		
	RBactivateScroller = new JRadioButton();
	RBactivateTable = new JRadioButton();
	quantChoser.add(RBactivateScroller);
	quantChoser.add(RBactivateTable);
	
	RBactivateScroller.setSelected( true );
	RBactivateTable.setSelected( false );
		
	// festlegen der Transprenz	
	CBimageChoser.setOpaque(false);
	RBactivateScroller.setOpaque(false);
	RBactivateTable.setOpaque(false);		
	SBquantSlider.setOpaque(false);
	BshowQTable.setOpaque(false);
	iim.setOpaque(false);
	oim.setOpaque(false);
	dsbg.setOpaque(false);	
	qsbg.setOpaque(false);	
	
	// Listener "dranpacken"
	RBactivateScroller.addActionListener((ActionListener)parent.evth);
	RBactivateTable.addActionListener((ActionListener)parent.evth);
	CBimageChoser.addActionListener((ActionListener)parent.evth);	
	BshowQTable.addActionListener((ActionListener)parent.evth);
	TFquantManuel.addActionListener((ActionListener)parent.evth);	
	inputImagePanel.addMouseListener((MouseListener)parent.evth);	
	SBquantSlider.addAdjustmentListener((AdjustmentListener)parent.evth);	
	
	// gbc grid festlegen		
    int rowHeights[] = { 10,40,80,10,15,85,40,100,10,20,20,20,25,5};
    int columnWidths[] = { 70,100,10,30,20,30,40,40,90,30,10,100,70};
    double rowWeights[] = { 0,0,0,0,0,0,0,0,0,0,0,0 };
    double columnWeights[] = { 0,0,0,0,0,0,0,0,0 };
    gbl.rowHeights = rowHeights;
    gbl.columnWidths = columnWidths;
    gbl.rowWeights = rowWeights;
    gbl.columnWeights = columnWeights;
		
	// Margin setzen
	BshowQTable.setMargin(new Insets(-2,0,-2,0));
	
	// Grössen der Komponenten festlegen	
	inputImagePanel.setSize(new Dimension(120,120));
	outputImagePanel.setSize(new Dimension(120,120));
	
	iim.setSize(new Dimension(100,100));
	oim.setSize(new Dimension(100,100));
	
	dsbg.setSize(new Dimension(100,100));
	qsbg.setSize(new Dimension(100,100));
	
	CBimageChoser.setSize(new Dimension(120,25));		
	RBactivateScroller.setSize(new Dimension(20,20));
	RBactivateTable.setSize(new Dimension(20,20));
	LtableText.setSize(new Dimension(200,20));
	LscrollerText.setSize(new Dimension(200,20));
	TFquantManuel.setSize(new Dimension(30,20));
	SBquantSlider.setSize(new Dimension(130,18));
	BshowQTable.setSize(new Dimension(250,20));
			
	resetConstraints();
	
	gbc.fill = gbc.BOTH;
    gbc.weightx = 0.0;
    gbc.weighty = 0.0;    
    
    // input picture
    gbc.gridwidth = 4;
    gbc.gridheight = 2;    
    insertComponent( inputImagePanel, 3, 1 );
    
    // output picture
    gbc.gridwidth = 2;
    gbc.gridheight = 2;
    insertComponent( outputImagePanel, 8, 1 );
    
	// linke Farb Matrix
    gbc.gridwidth = 1;
    gbc.gridheight = 2;      
    gbc.ipadx = 1;
    gbc.insets = new Insets( 8, 8, 0, 0 );
    insertComponent( iim, 1, 4 );
          
    // rechte Farb Matrix
    gbc.ipadx = 1;
    gbc.insets = new Insets( 8, 8, 0, 0 );
    gbc.gridwidth = 1;
    gbc.gridheight = 2;    
    insertComponent( oim, 11, 4 );
    
    // linkes Balken Diagramm
    gbc.ipadx = 0;
    gbc.insets = new Insets( 0, 0, 0, 0 );
    gbc.gridwidth = 1;
    gbc.gridheight = 1;    
    insertComponent( dsbg, 1, 7);
    
    // rechtes Balken Diagramm
    gbc.gridwidth = 1;
    gbc.gridheight = 1;    
    insertComponent( qsbg, 11, 7 );
    
    // RadioButtons
    gbc.gridwidth = 1;
    gbc.gridheight = 1;
    insertComponent( RBactivateTable, 4, 9 );
    insertComponent( RBactivateScroller, 4, 10 );
    
    // Labels
    gbc.gridwidth = 4;
    gbc.gridheight = 1;
    insertComponent( LtableText, 5, 9 );
    insertComponent( LscrollerText, 5, 10 );
    
    // TextField
    gbc.gridwidth = 1;
    gbc.gridheight = 1;
    insertComponent( TFquantManuel, 5, 11 );
    
    // Button
    gbc.gridwidth = 5;
    gbc.gridheight = 1;
    gbc.fill = gbc.HORIZONTAL;
    insertComponent( BshowQTable, 4, 12 );
    
    // Scrollbar
    gbc.gridwidth = 3;
    gbc.gridheight = 1;
    gbc.fill = gbc.HORIZONTAL;
    gbc.insets = new Insets( 1, 5, 1, 5 );
    insertComponent( SBquantSlider, 6, 11 );
    
    // ComboBox
    gbc.gridwidth = 4;
    gbc.gridheight = 2;
    gbc.insets = new Insets( 0, 0, 0, 0 );
    insertComponent( CBimageChoser, 3, 3 );
    	        
	parent.getContentPane().add(mainPanel);
	parent.pack();
			
} // end of constructor	
	
	
//********************************************METHODS**************************************************************	

public void insertComponent( JComponent c, int x, int y ) {
	gbc.gridx = x;
	gbc.gridy = y;
	gbl.setConstraints( c, gbc );	
	mainPanel.add( c );
}

public void resetConstraints() {
    gbc.gridx = 0;
    gbc.gridy = 0;
    gbc.gridwidth = 1;
    gbc.gridheight = 1;
    gbc.fill = gbc.BOTH;
    gbc.anchor = gbc.CENTER;
    gbc.insets = new Insets( 0, 0, 0, 0 );
    gbc.ipadx = 0;
    gbc.ipady = 0;
    gbc.weightx = 1.0;
    gbc.weighty = 1.0;    
}

} // end of class TheGUI