// TheIDCT.java

import java.lang.Math;


class TheIDCT {
	
  TheFrame parent;  
  
  double[][] C,Ct;           // C  <= Cosine Transform Matrix, Ct <= Transposed C
  int N = 8;                   // Block-Size


public TheIDCT ( TheFrame parent ) {
    
    this.parent = parent;
        
    C =new double[N][N];
    Ct=new double[N][N];    
        
    for (int i=0;i<N;i++) {
      C [0][i]=1.0/Math.sqrt(N);
      Ct[i][0]=C[0][i];
    }
    for(int i=1;i<N;i++)
    for(int j=0;j<N;j++) {
		C [i][j]=Math.sqrt(2.0/N)*Math.cos((2*j+1)*i*Math.PI/(2.0*N));
		Ct[j][i]=C[i][j];
    }
        
} // end of constructor

/*
public double[][] inverseDCT(double[][] in)
{			
	double[][] out = new double[8][8]; // usf = user sample field
	double Cu = 0, Cv = 0;
	double sumu, sumv, cosu, cosv;
	double pi = Math.PI;
	double sqrt2 = Math.sqrt(2);				

		
	for (int y = 0; y < 8; y++)
	for (int x = 0; x < 8; x++)
	{
		sumv = 0;
		for (int v = 0; v < 8; v++)
		{				
			sumu = 0;				
			for (int u = 0; u < 8; u++)
			{
				if (u == 0) { Cu = 1/sqrt2;} else { Cu = 1;}
				cosu = Math.cos( (2*x+1)*u*pi/16 );
				cosv = Math.cos( (2*y+1)*v*pi/16 );
				sumu += 0.5*Cu*in[v][u]*cosu*cosv;
			} // end of for (u ...
			
			if (v == 0) { Cv = 1/sqrt2;} else { Cv = 1;}
			sumv += 0.5*Cv*sumu;				
		} // end of for (v ...
			
		//usf[y][x] = (int)Math.round(sumv)+128; // +128 = zero shift
		out[y][x] = sumv+128;
			
	} // end of outer double sum
				
	return out;
		
} // end of public int[][] backtransformation( ... )

*/

public double[][] inverseDCT(double[][] in) {
	
    double [][] input = in;
    double [][] output = new double[N][N];
    double[][] tmp = new double[N][N];
    double out;
    
    for(int i=0;i<N;i++)
    for(int j=0;j<N;j++) {
		tmp[i][j]=0.0;
		for(int k=0;k<N;k++) { tmp[i][j] += (input[i][k]*C[k][j]); }
    }
    
    for(int i=0;i<N;i++)
    for(int j=0;j<N;j++) {
		out=0.0;
		for(int k=0;k<N;k++) { out += Ct[i][k]*tmp[k][j]; }
		out+=128.0;		
		{output[i][j] = (int)Math.round(out);}
    }    
    return ( output );
    
}// end of inverseDCT

} // end of class









