// TheQuantizer.java

import java.lang.Math;

class TheQuantizer {
  
	TheFrame parent;  		
	int[][] qTableLumi;
	int[][] qTableChro;
	int w;

// Constructor for blockwise DCT
public TheQuantizer ( TheFrame parent ){

	this.parent = parent;	
    qTableLumi = new int[8][8];
    qTableChro = new int[8][8];
    w = 1;
    setNewQuantizeTable( w );
}


public void setNewQuantizeTable(int which) {		
	
	if (which == 0) {
		
		qTableLumi = new int[][] {
			{ 16, 11, 10, 16, 24, 40, 51, 61}, /*16*/
			{ 12, 12, 14, 19, 26, 58, 60, 55},
			{ 14, 13, 16, 24, 40, 57, 69, 56},
			{ 14, 17, 22, 29, 51, 87, 80, 62},
			{ 18, 22, 37, 56, 68,109,103, 77},
			{ 24, 35, 55, 64, 81,104,113, 92},
			{ 49, 64, 78, 87,103,121,120,101},
			{ 72, 92, 95, 98,112,100,103, 99}};
			
		qTableChro = new int[][] {
			{ 17, 18, 24, 47, 99, 99, 99, 99}, /*17*/
			{ 18, 21, 26, 66, 99, 99, 99, 99},
			{ 24, 26, 56, 99, 99, 99, 99, 99},
			{ 47, 66, 99, 99, 99, 99, 99, 99},
			{ 99, 99, 99, 99, 99, 99, 99, 99},
			{ 99, 99, 99, 99, 99, 99, 99, 99},
			{ 99, 99, 99, 99, 99, 99, 99, 99},
			{ 99, 99, 99, 99, 99, 99, 99, 99}};
		
		w = 0;	
		
	} else {
		
		qTableLumi = new int[8][8];
		qTableChro = new int[8][8];
		
		for(int i=0;i<8;i++)
    	for(int j=0;j<8;j++) {
			qTableLumi[i][j] = which;
			qTableChro[i][j] = which;
		}
		qTableLumi[0][0] = 1;
		qTableChro[0][0] = 1;		
		w = which;
				
	}// else	
}// setNewQuantizeTable

// Luminance quant. (quant. und dequant.)
public double[][] quantY( double[][] in) {    
		
    double[][] out = new double[8][8];
    double valuePrev, valueThis;
      
    for (int k = 0; k<8; k++) out[k] = (double[])in[k].clone();
    
    for(int i=0;i<8;i++)
    for(int j=0;j<8;j++) {    	
    	    	
		out[i][j] /= qTableLumi[i][j];		
		
		if (out[i][j] < 0) {out[i][j] = (int)Math.ceil(out[i][j]);}
		else if (out[i][j] > 0) {out[i][j] = (int)Math.floor(out[i][j]);}		
		
		out[i][j] *= qTableLumi[i][j];		
    }    
return( out );
}

//Chrominance quant. (quant. und dequant.)
public double[][] quantUV( double[][] in) {    
	
    double[][] out = new double[8][8];
      
    for (int k = 0; k<8; k++) out[k] = (double[])in[k].clone();    
    for(int i=0;i<8;i++)
    for(int j=0;j<8;j++) {	
    	    		
		out[i][j] /= qTableChro[i][j];
		
		if (out[i][j] < 0) {out[i][j] = (int)Math.ceil(out[i][j]);}
		else if (out[i][j] > 0) {out[i][j] = (int)Math.floor(out[i][j]);}
		
		out[i][j] *= qTableChro[i][j];		
    }    
return( out );
}

/*
// Luminance quant.
public double[][] quantizeY( double[][] in) {    
		
    double[][] out = new double[8][8];
      
    for (int k = 0; k<8; k++) out[k] = (double[])in[k].clone();    
    for(int i=0;i<8;i++)
    for(int j=0;j<8;j++) {    	
		out[i][j] = out[i][j]/qTableLumi[i][j];
		if (out[i][j] < 0) {out[i][j] = Math.ceil(out[i][j]);}
		else if (out[i][j] > 0) {out[i][j] = Math.floor(out[i][j]);}		
    }    
return( out );
}

//Chrominance quant.
public double[][] quantizeUV( double[][] in) {    
	
    double[][] out = new double[8][8];
      
    for (int k = 0; k<8; k++) out[k] = (double[])in[k].clone();    
    for(int i=0;i<8;i++)
    for(int j=0;j<8;j++) {		
		out[i][j] = out[i][j]/qTableChro[i][j];
		if (out[i][j] < 0) {out[i][j] = Math.ceil(out[i][j]);}
		else if (out[i][j] > 0) {out[i][j] = Math.floor(out[i][j]);}
    }    
return( out );
}

// Luminance DEquant.
public double[][] dequantizeY( double[][] in) {    
		
    double[][] out = new double[8][8];
    
    for (int k = 0; k<8; k++) out[k] = (double[])in[k].clone();    
    
    for(int i=0;i<8;i++)
    for(int j=0;j<8;j++) {		
		out[i][j] = out[i][j]*qTableLumi[i][j];
    }
return( out );
}

//Chrominance DEquant.
public double[][] dequantizeUV( double[][] in) {    
	
    double[][] out = new double[8][8];
    
    for (int k = 0; k<8; k++) out[k] = (double[])in[k].clone();    
    
    for(int i=0;i<8;i++)
    for(int j=0;j<8;j++) {		
		out[i][j] = out[i][j]*qTableChro[i][j];
    }
return( out );
}
*/

} // end of class

