// Tutorial.java

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

class Tutorial extends JDialog implements ActionListener {
	
Toolkit tk = Toolkit.getDefaultToolkit();
Dimension screenDim = tk.getScreenSize();
TheFrame parent;
	
JPanel mainPanel = new JPanel(new BorderLayout());
		
JButton AUTOCALC = new JButton();

JMenuBar mb = new JMenuBar();
JMenuItem backB, nextB, homeB, closeB;
JMenuItem step1B, step2B, step3B, step4B;
JMenu gotoM;

int currentStep = 0, MAXSTEPS = 4;

JScrollPane scroller;
JTextArea ta = new JTextArea();
JLabel headerL = new JLabel("",(int)JLabel.CENTER_ALIGNMENT);;
String txt;

	
Tutorial(TheFrame frame) {
	
	super((JFrame)frame, "Tutorial",false);
	setSize(600,450);
	setLocation((screenDim.width-600)/2,(screenDim.height-450)/2);	
	setResizable(true);  //false
	parent = frame;
									
	createMenuBar();	
	
	ta.setLineWrap(true);
	ta.setWrapStyleWord(true);
	ta.setEditable(false);
	ta.setFont(new Font("Monospaced",Font.PLAIN,12));
	scroller = new JScrollPane(ta,JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
	
	mainPanel.add(headerL,"North");
	mainPanel.add(scroller,"Center");
		
	AUTOCALC.addActionListener( this );
		
	getContentPane().setLayout(new BorderLayout());	
	getContentPane().add(mainPanel,"Center");
	step0();
	show();
			
} // constructor



void step0() {
	
	txt = 	
	"Here you will learn how to use this applet. But first you get some hints for this tutorial.\n\n" +	
	"In the menubar of this window you can choose what you want to do:\n" +
	"QUIT: Hmm, here is nothing to explain...\n" +
	"HOME: From any step within this tutorial you can come back to THIS page you are currently reading.\n" +
	"BACK: Go back to a previous step.\n" +	
	"NEXT: Proceed to a following step.\n" +	
	"JUMP TO: Here you can select directly a step.\n\n" +
	"Now press the NEXT button to go to the first step!";	
	
	ta.setText(txt);		
	headerL.setText("Welcome to the Tutorial");		
	validate();
}

void step1() {
	
	txt = 	
	"The upper left GUI (Graphical User Interface) component contains the SOURCE picture. The selected picture is used for the further operations.\n" +	
	"If you want to change the picture, simply select an other image from the combobox below this GUI component.\n\n" +
	"The available pictures were displayed in the RGB color space. However, the original data are typically processed in some type of luminance-chrominance color space, such as YCbCr or YUV. " +
	"In this applet the color transformation between RGB and YUV is used.\n\n" +
	"The upper right GUI component contains the TARGET image. Changing the quantization factor will affect this image. So you can see the difference between the original picture and the result of the quantization.\n\n" +
	"Within the SOURCE picture you can see a glowing rectangle. The area which is surrounded by this rectangle is shown magnified in the left GUI component which seems to consist of a 8x8 matrix of tiles.\n" +
	"By clicking with the left button of your mouse in the SOURCE image you can change the position of the rectangle.\n\n" +
	"Now preceed to the NEXT step.";	
	
	ta.setText(txt);	
	headerL.setText("Step 1: The Source and the Target Pictures");	
	validate();
}

void step2() {
	
	txt = 	
	"The GUI components which look like 8x8 matrices show an enlarged version of the area surrounded by the glowing rectangle in the SOURCE picture.\n" +
	"Similar to SOURCE and TARGET picture, the left matrix displays the original magnification of the area and the right matrix shows the result of the quantization.\n" +
	"If you want an area in the SOURCE image to be magnified, again, just click with the left mouse button in the SOURCE picture.\n\n" +	
	"Please go to the NEXT step.\n";
	
	ta.setText(txt);	
	headerL.setText("Step 2: The Magnified Areas");
	validate();
}

void step3() {
	
	txt = 	
	"The 3D bargraphs show the values of the coefficients AFTER the DCT (Discrete Cosine Transform) was applied to the values of the colors shown in the left 8x8 matrix.\n" +	
	"More detailed: Each tile within the 8x8 matrix represents a color. In this applet the YUV color space is used. Thus, each tile has an luminance component (Y) and two chrominace components (U and V). So there are three matrices, each containing either the Y values, the U values or the V values. The DCT is applied to each matrix separately.\n" +
	"The Y values of each tile from the left 8x8 matrix were shown in the left 3D bargraph picture.\n" +
	"The right 3D bargraphs, show the effect of the quantization of the Y values.\n\n" +
	"Proceed to the NEXT step.\n";
	
	ta.setText(txt);	
	headerL.setText("Step 3: The 3D Bargraphs");	
	validate();
}

void step4() {
	
	txt = 	
	"The most important place in the applet can be found in the lower middle area which is titled \"QUANTIZATION\".\n" +
	"Each coefficient you got as output from the DCT is divided by a number. In the JPEG standard two special quantize tables are used: The first table for the luminance values, the second table for the chrominace values.\n" +
	"In this applet you can choose if you want to use the JPEG standard tables or if you want to select your own value for the quantization. If you decided to select a number you can use a scrollbar to set the value. All but one coefficients were then divided by your selected number. The coefficient in the upper left corner (the DC coeffcient) is not modified.\n" +
	"The idea of (JPEG) quantization:\n" +
	"Each coefficient in an 8x8 matrix is divided by 'its own' number taken from a table. Because of the fact that higher frequencies are less important than the lower frequencies (human perception, psychovisual experiments), the lower frequencies' coefficients were divided by greater numbers than the higher frequencies coefficients. Using this great numbers for the quantization of the higher frequecies coefficients will result in a lot of zeros in the lower right corner of the 8x8 matrix. By 'making a lot of zeros' a higher compression is achieved, but this will also increase the blockiness of the TARGET picture.\n" +
	"\n" +
	"\n";
	
	ta.setText(txt);	
	headerL.setText("Step 4: The Quantization");	
	validate();
}




void createMenuBar() {
	
	closeB = new JMenuItem("Quit");
	homeB = new JMenuItem("Home");
	backB = new JMenuItem("Back");
	nextB = new JMenuItem("Next");
	gotoM = new JMenu("Jump to");
	
	step1B = new JMenuItem("Step 1: The Source and the Target Pictures");
	step2B = new JMenuItem("Step 2: The Magnified Areas");
	step3B = new JMenuItem("Step 3: The 3D Bargraphs");
	step4B = new JMenuItem("Step 4: The Quantization");
	gotoM.add(step1B);
	gotoM.add(step2B);
	gotoM.add(step3B);
	gotoM.add(step4B);
	
	mb.add(closeB);
	mb.add(homeB);
	mb.add(backB);
	mb.add(nextB);
	mb.add(gotoM);
	
	closeB.addActionListener( this );
	homeB.addActionListener( this );
	backB.addActionListener( this );
	nextB.addActionListener( this );
	step1B.addActionListener( this );
	step2B.addActionListener( this );
	step3B.addActionListener( this );
	step4B.addActionListener( this );
	
	setJMenuBar(mb);
}


public void actionPerformed(ActionEvent evt) {	
	
	if (evt.getSource() == closeB) {
		currentStep = 0;
		dispose();
	}
	
	if (evt.getSource() == homeB) {
		currentStep = 0;		
	}
	
	if (evt.getSource() == backB) {
		currentStep -= 1;
		if (currentStep < 0) currentStep = 0;		
	}
	
	if (evt.getSource() == nextB) {
		currentStep += 1;
		if (currentStep > MAXSTEPS) currentStep = MAXSTEPS;
	}
	
	if (evt.getSource() == step1B) {
		currentStep = 1;
	}
	
	if (evt.getSource() == step2B) {
		currentStep = 2;
	}
	
	if (evt.getSource() == step3B) {
		currentStep = 3;
	}
	
	if (evt.getSource() == step4B) {
		currentStep = 4;
	}
	
	if (evt.getSource() == AUTOCALC) {
		parent.sdct.start();
		parent.bdct.start();
	}	
	
	if (currentStep == 0) step0();
	if (currentStep == 1) step1();
	if (currentStep == 2) step2();
	if (currentStep == 3) step3();
	if (currentStep == 4) step4();
	
		
} // end actionPerformed
		
} // end of class